<?php
	session_start();
	unset($_SESSION["active"]);
	require("global.php");
	date_default_timezone_set("Asia/Hong_Kong");
?>
<!doctype html>
<html>
<head>
<title>Lunch Gathering - Enter your name</title>
<style>
body {
	font-family: Arial, "Helvetica Neue", Helvetica, sans-serif;
}
img {
	width: 300px;
	text-align: center;
}
<?php
	require_once "mobile_detect.php";
	$detect = new Mobile_Detect;
	if ($detect->isMobile()) { /* Check the device is desktop or mobile */
		echo "
			#header {
				font-size: 4em;
			}
			#title {
				font-size: 2.5em;
			}
			#main {
				font-size: 2.5em;
			}
			#content p {
				font-size: 2em;
			}
			.radio_width {
				font-size: 2em;
			}
			table td {
				font-size: 2.5em;
			}
			input {
				font-size: 1.5em;
			}
			input[type=radio] {
				border: 0px;
				width: 60%;
				height: 1em;
			}
			#button {
				width: 50%;
				height: 2.5em;
				margin: 30px 0 100px 0;
				font-size: 2.5em;
			}
			table td {
				padding-bottom: 20px;
			}
		";
	} else {
		echo "
			#header {
				font-size: 2.5em;
			}
			#title {
				font-size: 1.2em;
			}
			#main {
				font-size: 1em;
			}
			#content p {
				font-size: 0.9em;
			}
			.radio_width {
				font-size: 1em;
			}
			#button {
				width: 150px;
				height: 30px;
				margin: 10px 0;
			}
			table td {
				padding-bottom: 8px;
			}
		";
	}
?>
#header {
	text-align: center;
	font-weight: 700;
	color: #EC3E7D;
}
#title {
	color: #FFA600;
	font-weight: 700;
}
#main {
	margin-bottom: 20px;
}
#content {
	margin-top: 50px;
	text-align: center;
}
.radio_width {
	width: 10%;
	text-align: center;
}
table {
	margin-left: auto;
	margin-right: auto;
}
table td {
	text-align: left;
	color: #9400D3;
}
hr {
	width: 80%;
}
</style>
</head>
<body>
<?php
	function choice_select($i, $limit, $choice) { /* Function to handle when user selects the lunch box  */
		if ($i > $limit) { /* Check if the selected lunch box is greater than the limit setting */
			echo "
				<div id='header'>
				<p><img src='soldout.jpg'></p>
				Your choose Set ".$choice." is sold out.  Please back to previous page to choose another one.
				</div>
			";
		} else {
			if (!isset($_SESSION["save_choice"]) && isset($_POST["security"])) {  /* Check is user presses the refresh button by $_SESSION["save_choice"] and user must directs from the index.php */
				$d = date('Y/m/d h:i:sa');
				file_put_contents("choice.txt", $choice.','.$d.','.$_POST["security"].PHP_EOL , FILE_APPEND); /* Save user choice in choice.txt */
				$_SESSION["save_choice"] = "active"; /* Enable the session so the program knows that user selects the choice already */
				/* Let user enters the personal information */
				echo "
					<div id='header'>
					<p><img src='name.jpg'></p>
					Please enter your information.
					</div>
					<div id='content'>
					<form action='' method='POST'>
					<div id='main'>You have chose Set ".$choice.".</div>
					<div id='main'>Enter your name: <input type='text' name='username' required></div>
					<div id='main'>Enter your email address: <input type='email' name='email' required></div>
					<input type='hidden' name='confirm' value='".$choice."'>
					<input type='hidden' name='security' value='".$_POST["security"]."'>
					<input id='button' type='submit' value='Submit'>
					</form>
					</div>
				";
			} else {
				session_expire("Session expired.  Please restart your browser for next registration.");
			}
		}
	}
	
	function session_expire($err) { /* Function to handle error message */
		echo "<div id='header'><p><img src='sorry.jpg'></p>".$err."</div>";
	}

	if ($_SERVER["REQUEST_METHOD"] == "POST") { /* User has submitted the choice of lunch box from index.php */
		if (isset($_POST["choice"])) {
			/* The following code checks is the last lunch box from set A-D is selected by other */
			$a = 0;
			$b = 0;
			$c = 0;
			$d = 0;
			$e = 0;
			$c1 = $_POST["choice"]; /* Get user choice from the sent form */
			$c2 = substr($c1, 0, 1); /* Get the choice first character, A-D */
			switch ($c2) { /* Add set A-D for 1pc that indicates user choice */
				case "A":
					$a++;
					break;
				case "B":
					$b++;
					break;
				case "C":
					$c++;
					break;
				case "D":
					$d++;
					break;
				default:
					$e++;
			}
			$fh = fopen("choice.txt", "r"); 
			while (!feof($fh)) { /* Check the all choices in choice.txt to indicate the latest status.  Concurrent selection by users consideration */
				$line = fgets($fh); 
				$char = substr($line, 0, 1);
				switch ($char) {
					case "A":
						$a++;
						break;
					case "B":
						$b++;
						break;
					case "C":
						$c++;
						break;
					case "D":
						$d++;
						break;
					default:
						$e++;
				}
			}
			switch ($c2) { /* If last order is chosen, run the function to tell user selects the other set, or tell him/her to enter the personal information.  */
				case "A";
					choice_select($a, $a_limit, $_POST["choice"]);
					break;
				case "B";
					choice_select($b, $b_limit, $_POST["choice"]);
					break;
				case "C";
					choice_select($c, $c_limit, $_POST["choice"]);
					break;
				case "D";
					choice_select($d, $d_limit, $_POST["choice"]);
					break;
			}
		}
		if (isset($_POST["username"])) { /* Run the following code if user has entered the personal information */
			if (!isset($_SESSION["enter_name"])) { /* Check is user presses the refresh button by $_SESSION["enter_name"] */
				if(strpos(file_get_contents("record.txt"), $_POST["email"]) == true) { /* Check user inputted email is existing in record.txt.  It means user uses this email to order the lunch box already */
					session_expire("Your chose the lunch set by your email already.");
				} else {
					$d = date('Y/m/d h:i:sa');
					$f = file_get_contents("choice.txt");
					$lines = explode("\n", $f); /* Locate each line in choice.txt */
					foreach($lines as $line) {
						if(strpos($line, $_POST["security"]) == true) { /* Use $_POST["security"] to locate the correct line of record in choice.txt */
							$s = explode(",", $line); /* Explode the line and find the time in exploded array */
							if ((strtotime("now")-strtotime($s[1]))/60 >= 10) { /* Compare the system time and the time for user selects the lunch box.  If the time is greater than 10 minutes, the program will not save the user choice in record.txt */
								session_expire("Session expired.  It is too long to enter the contact information.");
							} else {
								$ip = $_SERVER['REMOTE_ADDR'];
								$file = "record.txt";
								file_put_contents($file, $d.','.$ip.','.$_POST["username"].",".$_POST["email"].",".$_POST["confirm"].",".$_POST["security"].PHP_EOL , FILE_APPEND); /* Save user choice and personal information in record.txt.  It is the last prcoedure for the lunch box selected by user */
								$_SESSION["enter_name"] = "active"; /* /* Check is user presses the refresh button by $_SESSION["enter_name"] */
								echo "
									<div id='header'>
									<p><img src='done.jpg'></p>
									Registration Completed.
									</div>
								";
							}
						}
					}
				}
				exit();
			} else { /* Check refresh is pressed when user has entered the name already */
				session_expire("Session expired.  Please restart your browser for next registration.");
			}
		}
		exit();
	} else { /* Check refresh is pressed when user is not directed from right page */
		session_expire("Session expired.  Please restart your browser for next registration.");
	}
?>
</body>
</html>